﻿--[[---------------------------------------------------------------------------

Copyright (c) 2008 by K. Scott Piel 
All Rights Reserved

E-mail: < kscottpiel@gmail.com >
Web:    < http://www.scottpiel.com >

This file is part of nUI.

    nUI is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    nUI is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with nUI.  If not, see <http://www.gnu.org/licenses/>.
	
THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR 
A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT 
OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT 
LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, 
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY 
THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT 
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE 
USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

--]]---------------------------------------------------------------------------
	
-------------------------------------------------------------------------------
-- default layout values

nUI_FactionBar_Layout =
{
	width  = 515,
	height = 18,
	
	Options =
	{
		cur_value = "none",	
		max_value = "none",	
	},
	
	Colors =
	{
		min = { r = 0, g = 0.3, b = 0.98, a = 1, },
		mid = { r = 0, g = 0.3, b = 0.98, a = 1, },
		max = { r = 0, g = 0.3, b = 0.98, a = 1, },
		bg  = { r = 0, g = 0, b = 0, a = 0, },
		overlay  = "Interface\\AddOns\\nUI\\Bars\\Art\\nUI_BarOverlay2.blp",
	},
	
	Origin =
	{
		anchor = "TOPLEFT",
		xOfs   = 168,
		yOfs   = -232,
	},
	
	Label =
	{
		anchor = "CENTER",
		size   = 22,
		xOfs   = 0,
		yOfs   = 25,
		Color  =
		{
			r = 0.6,
			g = 0.85,
			b = 1,
		},
	},
};

nUI.Class.FactionBarLayout = nUI.Class:CreatePrototype( nUI.Class.StatusLayout );
local prototype            = nUI.Class.FactionBarLayout.prototype;

-------------------------------------------------------------------------------
-- this may look a little like a PITA, but it makes it possible to add new values
-- at any time without having to parse the existing user config and insert, etc.

function prototype:init( user_defined )

	if not user_defined then user_defined = {}; end
	if not user_defined.Options then user_defined.Options = {}; end
	if not user_defined.Colors then user_defined.Colors = {}; end
	if not user_defined.Colors.min then user_defined.Colors.min = {}; end
	if not user_defined.Colors.mid then user_defined.Colors.mid = {}; end
	if not user_defined.Colors.max then user_defined.Colors.max = {}; end
	if not user_defined.Colors.bg then user_defined.Colors.bg = {};	 end
	if not user_defined.Origin then user_defined.Origin = {}; end
	if not user_defined.Label then user_defined.Label = {}; end
	if not user_defined.Label.Color then user_defined.Label.Color = {}; end
	
	prototype.super.prototype.init( self, user_defined );
	
	self.width  = tonumber( user_defined.width or nUI_FactionBar_Layout.width );
	self.height = tonumber( user_defined.height or nUI_FactionBar_Layout.height );
	
	self.Options.cur_value = strlower( user_defined.Options.cur_value or nUI_FactionBar_Layout.Options.cur_value );
	self.Options.max_value = strlower( user_defined.Options.max_value or nUI_FactionBar_Layout.Options.max_value );
	
	self.Colors.min =
	{
		r = tonumber( user_defined.Colors.min.r or nUI_FactionBar_Layout.Colors.min.r ),
		g = tonumber( user_defined.Colors.min.g or nUI_FactionBar_Layout.Colors.min.g ),
		b = tonumber( user_defined.Colors.min.b or nUI_FactionBar_Layout.Colors.min.b ),
		a = tonumber( user_defined.Colors.min.a or nUI_FactionBar_Layout.Colors.min.a ),
	};
	
	self.Colors.mid =
	{
		r = tonumber( user_defined.Colors.mid.r or nUI_FactionBar_Layout.Colors.mid.r ),
		g = tonumber( user_defined.Colors.mid.g or nUI_FactionBar_Layout.Colors.mid.g ),
		b = tonumber( user_defined.Colors.mid.b or nUI_FactionBar_Layout.Colors.mid.b ),
		a = tonumber( user_defined.Colors.mid.a or nUI_FactionBar_Layout.Colors.mid.a ),
	};

	self.Colors.max =
	{
		r = tonumber( user_defined.Colors.max.r or nUI_FactionBar_Layout.Colors.max.r ),
		g = tonumber( user_defined.Colors.max.g or nUI_FactionBar_Layout.Colors.max.g ),
		b = tonumber( user_defined.Colors.max.b or nUI_FactionBar_Layout.Colors.max.b ),
		a = tonumber( user_defined.Colors.max.a or nUI_FactionBar_Layout.Colors.max.a ),
	};
	
	self.Colors.bg =
	{
		r = tonumber( user_defined.Colors.bg.r or nUI_FactionBar_Layout.Colors.bg.r ),
		g = tonumber( user_defined.Colors.bg.g or nUI_FactionBar_Layout.Colors.bg.g ),
		b = tonumber( user_defined.Colors.bg.b or nUI_FactionBar_Layout.Colors.bg.b ),
		a = tonumber( user_defined.Colors.bg.a or nUI_FactionBar_Layout.Colors.bg.a ),
	};
	
	self.Origin =
	{
		anchor = strupper( user_defined.Origin.anchor or nUI_FactionBar_Layout.Origin.anchor ),
		xOfs   = tonumber( user_defined.Origin.xOfs or nUI_FactionBar_Layout.Origin.xOfs ),
		yOfs   = tonumber( user_defined.Origin.yOfs or nUI_FactionBar_Layout.Origin.yOfs ),
	};

	self.Colors.overlay   = user_defined.Colors.overlay or nUI_FactionBar_Layout.Colors.overlay;

	self.Label =
	{
		anchor = strupper( user_defined.Label.anchor or nUI_FactionBar_Layout.Label.anchor ),
		size   = tonumber( user_defined.Label.size or nUI_FactionBar_Layout.Label.size ),
		xOfs   = tonumber( user_defined.Label.xOfs or nUI_FactionBar_Layout.Label.xOfs ),
		yOfs   = tonumber( user_defined.Label.yOfs or nUI_FactionBar_Layout.Label.yOfs ),
		
		Color =
		{
			r = tonumber( user_defined.Label.Color.r or nUI_FactionBar_Layout.Label.Color.r ),
			g = tonumber( user_defined.Label.Color.g or nUI_FactionBar_Layout.Label.Color.g ),
			b = tonumber( user_defined.Label.Color.b or nUI_FactionBar_Layout.Label.Color.b ),
		},
	};
end
